# Oracle APEX Plugin Pack - APEX Peekaboo

[![APEX Community](https://cdn.rawgit.com/rafael-trevisan/apex-github-badges/12a4f7be/badges/apex-community-badge.svg)](https://github.com/rafael-trevisan/apex-github-badges) [![APEX Plugin](https://cdn.rawgit.com/rafael-trevisan/apex-github-badges/12a4f7be/badges/apex-plugin-badge.svg)](https://github.com/rafael-trevisan/apex-github-badges)
[![APEX Built with Love](https://cdn.rawgit.com/rafael-trevisan/apex-github-badges/12a4f7be/badges/apex-love-badge.svg)](https://github.com/rafael-trevisan/apex-github-badges) [![Donate](https://img.shields.io/badge/Donate-PayPal-green.svg)](#donation) [![Donate Bitcoin](https://img.shields.io/badge/Donate-Bitcoin-orange.svg)](#donation)


This plug-in pack provides a set of a few standard APEX components (like region, text field, radio and checkbox) with a built-in visibility setting that is meant to implement show and hide actions with an easier and faster way than using Dynamic Actions.

Each component includes its own settings:

![](https://github.com/rafael-trevisan/apex-plugin-peekaboo/blob/master/docs/img/peekaboo-region-examples.png)

## Benefits
- Reduce development time
- Reduce mundane tasks
- Increase maintainability

## Install
- Import plugin files from `source` directory into your application.
	- `region_type_plugin_ca_trevis_apex_peekaboo_region.sql`
	- `item_type_plugin_ca_trevis_apex_peekaboo_textfield.sql`
	- `item_type_plugin_ca_trevis_apex_peekaboo_radiogroup.sql`
	- `item_type_plugin_ca_trevis_apex_peekaboo_checkbox.sql`
	- `item_type_plugin_ca_trevis_apex_peekaboo_simple_checkbox.sql`

## Demo Application
- Peekaboo Region: [https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-region](https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-region)
- Peekaboo Text Field: [https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-textfield](https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-textfield)
- Peekaboo Radio Group: [https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-radiogroup](https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-radiogroup)
- Peekaboo Checkbox: [https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-checkbox](https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-checkbox)
- Peekaboo Simple Checkbox: [https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-simple_checkbox](https://apex.oracle.com/pls/apex/f?p=trevis:peekaboo-simple_checkbox)

## Preview
## ![](https://github.com/rafael-trevisan/apex-plugin-peekaboo/blob/master/preview.gif)

## Changelog
[See changelog](changelog.md)

## Donation
If this project help you reduce time to develop, you can give me a :beer: :)

 - ![Donate](https://img.shields.io/badge/Donate-PayPal-green.svg) https://www.paypal.me/rafaeltrevisan
 - ![Donate Bitcoin](https://img.shields.io/badge/Donate-Bitcoin-orange.svg) 1KHNJEhkHfBsAnJ7hgUzaADJ35ExMvLWog
